
#include "structs.h"

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <conio.h>
#include <math.h>

#define DEF_DIF_LEN_SPOL 50
#define DEF_DIF_LEN_SAM 55
#define DEF_DIF_PITCH 180

#define AKC_PITCH_ADD_SAM 20 
#define AKC_LEN_ADD_SAM 30
#define AKC_PITCH_ADD_SPOL 15 
#define AKC_LEN_ADD_SPOL 20

#define AKCENT 2

#define PRZECINEK_LEN 120
#define SLOWO_ODSTEP_LEN 0
#define ZDANIE_ODSTEP_LEN 450

#define SLOWO_PITCH_RAND 10
#define SLOWO_1_PITCH_OFF 20

#define SLOWO_LAST_PITCH_OFF -35
#define SLOWO_LAST_LEN_OFF 10

#define SLOWO_LAST_PITCH_OFF_PYT 15
#define SLOWO_LAST_LEN_OFF_PYT 20


#define DIFON_RAND_OFF 10
#define DIFON_RAND_LEN_OFF 10

//extern "C"
//{
#include "scanner.h"

	void yyerror(char *str, ...)
	{
	}

	extern FILE *g_Plik;

	ValType g_Val;
	int g_bSam;

	extern int yylex();
//}

FILE *g_Out = NULL;

Tekst::Tekst(char *fname)
{
	g_Plik = fopen(fname, "r");

	if (!g_Plik) 
	{
		printf("Can not open %s!!!", fname);
		return;
	}
	
	int x;

	while (true )
	{
		g_bSam = false; 
		x = yylex();

		if (x == tGONG)
		{
			char *tmp = g_Val.str;
			g_Val.str = "N";
			AddZnak(tSTRCONST);
			g_Val.str = tmp+1;
			AddZnak(tSTRCONST);
		}
		else if (x == tFLOATCONST)
		{
 		  char buff[255];
		  sprintf(buff, "%f", g_Val.FloatConst);
		  
		  for (int l = strlen(buff)-1; l >= 0; l--)
		  {
		      if (buff[l] == '0') buff[l] = 0;
		      else break;
          }
		  
		  for (int l = 0; l < strlen(buff); l++)
		  {

		  switch (buff[l])
		  {
		      case '.':
              g_Val.str = "k";  AddZnak(tSTRCONST);              
              g_Val.str = "r";  AddZnak(tSTRCONST);              
              g_Val.str = "o";  AddZnak(tSTRCONST);              
              g_Val.str = "p";  AddZnak(tSTRCONST);              
              g_Val.str = "k";  AddZnak(tSTRCONST);              
              g_Val.str = "a";  AddZnak(tSTRCONST);              
              break;

		      case '0':
              g_Val.str = "z";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "r";  AddZnak(tSTRCONST);              
              g_Val.str = "o";  AddZnak(tSTRCONST);              
              break;
		      
		      case '1':
              g_Val.str = "j";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "d";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "n";  AddZnak(tSTRCONST);              
		      break;
		      
		      case '2':
		      g_Val.str = "d";  AddZnak(tSTRCONST);              
   		      g_Val.str = "v";  AddZnak(tSTRCONST);              
   		      g_Val.str = "a";  AddZnak(tSTRCONST);              
              break;
		      
		      case '3':
              g_Val.str = "t";  AddZnak(tSTRCONST);              
              g_Val.str = "S";  AddZnak(tSTRCONST);              
              g_Val.str = "I";  AddZnak(tSTRCONST);              
		      break;
		      
		      case '4':
              g_Val.str = "tS";  AddZnak(tSTRCONST);              
              g_Val.str = "t";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "r";  AddZnak(tSTRCONST);              
              g_Val.str = "I";  AddZnak(tSTRCONST);              
              break;
              
		      case '5':
		      g_Val.str = "p";  AddZnak(tSTRCONST);              
              g_Val.str = "i";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "n'";  AddZnak(tSTRCONST);              
              g_Val.str = "ts'";  AddZnak(tSTRCONST);        
              break;
		      
		      case '6':
		      g_Val.str = "S";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "s'";  AddZnak(tSTRCONST);              
              g_Val.str = "ts'";  AddZnak(tSTRCONST);              
		      break;

		      case '7':
   		      g_Val.str = "s'";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "d";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "m";  AddZnak(tSTRCONST);        
		      break;
		      
		      case '8':
   		      g_Val.str = "o";  AddZnak(tSTRCONST);              
              g_Val.str = "s'";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "m";  AddZnak(tSTRCONST);              
		      break;
		      
		      case '9':
   		      g_Val.str = "dz'";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "v";  AddZnak(tSTRCONST);              
              g_Val.str = "j";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);        
              g_Val.str = "n'";  AddZnak(tSTRCONST);        
              g_Val.str = "ts'";  AddZnak(tSTRCONST);        
		      break;
		  }
		  
	      //g_Val.str = ",";
	      //AddZnak(tINTERP);        
       }
       		
		
		
		
		}
		else if (x == tINTCONST)
		{
		  char buff[255];
		  sprintf(buff, "%d", g_Val.IntConst);
		  
		  for (int l = 0; l < strlen(buff); l++)
		  {

		  switch (buff[l])
		  {
		      case '0':
              g_Val.str = "z";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "r";  AddZnak(tSTRCONST);              
              g_Val.str = "o";  AddZnak(tSTRCONST);              
              break;
		      
		      case '1':
              g_Val.str = "j";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "d";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "n";  AddZnak(tSTRCONST);              
		      break;
		      
		      case '2':
		      g_Val.str = "d";  AddZnak(tSTRCONST);              
   		      g_Val.str = "v";  AddZnak(tSTRCONST);              
   		      g_Val.str = "a";  AddZnak(tSTRCONST);              
              break;
		      
		      case '3':
              g_Val.str = "t";  AddZnak(tSTRCONST);              
              g_Val.str = "S";  AddZnak(tSTRCONST);              
              g_Val.str = "I";  AddZnak(tSTRCONST);              
		      break;
		      
		      case '4':
              g_Val.str = "tS";  AddZnak(tSTRCONST);              
              g_Val.str = "t";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "r";  AddZnak(tSTRCONST);              
              g_Val.str = "I";  AddZnak(tSTRCONST);              
              break;
              
		      case '5':
		      g_Val.str = "p";  AddZnak(tSTRCONST);              
              g_Val.str = "i";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "n'";  AddZnak(tSTRCONST);              
              g_Val.str = "ts'";  AddZnak(tSTRCONST);        
              break;
		      
		      case '6':
		      g_Val.str = "S";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "s'";  AddZnak(tSTRCONST);              
              g_Val.str = "ts'";  AddZnak(tSTRCONST);              
		      break;

		      case '7':
   		      g_Val.str = "s'";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "d";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "m";  AddZnak(tSTRCONST);        
		      break;
		      
		      case '8':
   		      g_Val.str = "o";  AddZnak(tSTRCONST);              
              g_Val.str = "s'";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "m";  AddZnak(tSTRCONST);              
		      break;
		      
		      case '9':
   		      g_Val.str = "dz'";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);              
              g_Val.str = "v";  AddZnak(tSTRCONST);              
              g_Val.str = "j";  AddZnak(tSTRCONST);              
              g_Val.str = "e";  AddZnak(tSTRCONST);        
              g_Val.str = "n'";  AddZnak(tSTRCONST);        
              g_Val.str = "ts'";  AddZnak(tSTRCONST);        
		      break;
		  }
		  
	      //g_Val.str = ",";
	      //AddZnak(tINTERP);        
       }
             
		}
		else if (x == tSTRCONST || x == tINTERP)
		{
			AddZnak(x);
		}
		else
		{
			if (m_Zdania[m_Zdania.size()-1].m_Slowa.size() == 0)
			{
				m_Zdania.pop_back();
			}
			else
			{
				m_Zdania[m_Zdania.size()-1].CloseSlowo();
			}
			break;
		}
	}

	
	fclose(g_Plik);
}

void Tekst::AddZnak(int z)
{
	if (z == tSTRCONST)
	{
		if (m_Zdania.size() > 0)
		{
			m_Zdania[m_Zdania.size()-1].AddZnak(z);
		}
		else
		{
			m_Zdania.push_back(Zdanie());
			m_Zdania[m_Zdania.size()-1].AddZnak(z);
		}
	}
	else if (z == tINTERP)
	{
		if (strcmp(g_Val.str, ".") == 0)
		{
			m_Zdania[m_Zdania.size()-1].CloseSlowo();
			m_Zdania[m_Zdania.size()-1].Close();
			m_Zdania.push_back(Zdanie());
		}
		else if (strcmp(g_Val.str, ",") == 0)
		{
			g_Val.str = ",";
			m_Zdania[m_Zdania.size()-1].AddZnak(tSTRCONST);
		}
		else if (strcmp(g_Val.str, "!") == 0)
		{
			m_Zdania[m_Zdania.size()-1].CloseSlowo();
			m_Zdania[m_Zdania.size()-1].m_Typ = ZT_WYKRZYKNIKOWE;
			m_Zdania[m_Zdania.size()-1].Close();
			m_Zdania.push_back(Zdanie());
		}
		else if (strcmp(g_Val.str, "?") == 0)
		{
			m_Zdania[m_Zdania.size()-1].CloseSlowo();
			m_Zdania[m_Zdania.size()-1].m_Typ = ZT_PYTAJACE;
			m_Zdania[m_Zdania.size()-1].Close();
			m_Zdania.push_back(Zdanie());
		}
	}
}

void Tekst::Output()
{
	g_Out = fopen("output.pho", "w");
	
	printf("Tekst ma %d zda:\n", m_Zdania.size());
	for (int i = 0; i < m_Zdania.size(); i++)
	{
		m_Zdania[i].Output();
	}

	fclose(g_Out);
}

Zdanie::Zdanie()
{
	m_Typ = ZT_OZNAJMUJACE;
}

void Zdanie::Close()
{
	for (int i = 0; i < m_Slowa.size(); i++)
	{
		int off = rand()%SLOWO_PITCH_RAND;
		int len = rand()%10;
		if (i == 0) off += SLOWO_1_PITCH_OFF;
		
		if (m_Typ == ZT_PYTAJACE)
		{
			
			for (int w = 0; w < m_Slowa[0].m_Sylaby[0].m_Difony.size(); w++)
				m_Slowa[0].m_Sylaby[0].m_Difony[w].m_Param[2] += SLOWO_1_PITCH_OFF;
			
			if (i == m_Slowa.size()-1) 
			{
				off += SLOWO_LAST_PITCH_OFF_PYT;
				len += SLOWO_LAST_LEN_OFF_PYT;

				for (int w = 0; w < m_Slowa[i].m_Sylaby[m_Slowa[i].m_Sylaby.size()-1].m_Difony.size(); w++)
				{
					m_Slowa[i].m_Sylaby[m_Slowa[i].m_Sylaby.size()-1].m_Difony[w].m_Param[2] += SLOWO_1_PITCH_OFF;
                }

				m_Slowa[i].m_Sylaby[m_Slowa[i].m_Sylaby.size()-1].m_Difony[m_Slowa[i].m_Sylaby[m_Slowa[i].m_Sylaby.size()-1].m_Difony.size()-1].m_Param[2] += SLOWO_LAST_PITCH_OFF_PYT;
				m_Slowa[i].m_Sylaby[m_Slowa[i].m_Sylaby.size()-1].m_Difony[m_Slowa[i].m_Sylaby[m_Slowa[i].m_Sylaby.size()-1].m_Difony.size()-1].m_Param[0] += SLOWO_LAST_LEN_OFF_PYT*2;
			}
		}
		else if (m_Typ == ZT_WYKRZYKNIKOWE)
		{
            if (i == 0)	
                     for (int w = 0; w < m_Slowa[0].m_Sylaby[0].m_Difony.size(); w++)
			                     	m_Slowa[0].m_Sylaby[0].m_Difony[w].m_Param[2] += 30;
		
			off += 40.0f - 40.0f * i / m_Slowa.size();
			len += 0; //SLOWO_LAST_LEN_OFF_PYT;
		
  
		}
		else
		{
			if (i == m_Slowa.size()-1) 
			{
				off += SLOWO_LAST_PITCH_OFF;
				len += SLOWO_LAST_LEN_OFF;
			}
		}
		m_Slowa[i].Offset(off,len);
	}
}

void Zdanie::CloseSlowo()
{
	// Ubezdwicznianie wewntrz wyrazowe
	for (int s = 0; s < (int)m_Slowa[m_Slowa.size()-1].m_Sylaby.size()-1; s++)
	{
		if (m_Slowa[m_Slowa.size()-1].m_Sylaby[s].m_Difony[0].IsDzwieczny() && !m_Slowa[m_Slowa.size()-1].m_Sylaby[s+1].m_Difony[0].IsDzwieczny())
		{
			m_Slowa[m_Slowa.size()-1].m_Sylaby[s].m_Difony[0].ChangeToBezdzwieczny();
		}
	}
		
	// zamiana i na j przy mfvxlr i samogoska
	for (int s = 0; s < (int)m_Slowa[m_Slowa.size()-1].m_Sylaby.size()-2; s++)
	{
		if ((m_Slowa[m_Slowa.size()-1].m_Sylaby[s].m_Difony[0].m_pStr[0] == 'm' || 
			m_Slowa[m_Slowa.size()-1].m_Sylaby[s].m_Difony[0].m_pStr[0] == 'f' || 
			m_Slowa[m_Slowa.size()-1].m_Sylaby[s].m_Difony[0].m_pStr[0] == 'v' || 
			m_Slowa[m_Slowa.size()-1].m_Sylaby[s].m_Difony[0].m_pStr[0] == 'x' || 
			m_Slowa[m_Slowa.size()-1].m_Sylaby[s].m_Difony[0].m_pStr[0] == 'l' || 
			m_Slowa[m_Slowa.size()-1].m_Sylaby[s].m_Difony[0].m_pStr[0] == 'r' ) &&
			m_Slowa[m_Slowa.size()-1].m_Sylaby[s+1].m_Difony[0].m_pStr[0] == 'i' &&
			m_Slowa[m_Slowa.size()-1].m_Sylaby[s+2].m_Difony[0].m_bSam)
		{
			m_Slowa[m_Slowa.size()-1].m_Sylaby[s+1].m_Difony[0].m_pStr = "j";
		}
	}

	// ubezdzwicznianie sekwencji po gosce bezdzwicznej 
	for (int s = 0; s < (int)m_Slowa[m_Slowa.size()-1].m_Sylaby.size()-1; s++)
	{
		if (!m_Slowa[m_Slowa.size()-1].m_Sylaby[s].m_Difony[0].IsDzwieczny() &&
			(m_Slowa[m_Slowa.size()-1].m_Sylaby[s+1].m_Difony[0].m_pStr[0] == 'v' || 
			m_Slowa[m_Slowa.size()-1].m_Sylaby[s+1].m_Difony[0].m_pStr[0] == 'Z'))
		{
			m_Slowa[m_Slowa.size()-1].m_Sylaby[s+1].m_Difony[0].ChangeToBezdzwieczny();
		}
	}

    Slowo slow = m_Slowa[m_Slowa.size()-1].ProcessSyladebilus();

	int akcent = slow.m_Sylaby.size()-AKCENT;
	

	for (int s = 0; s < slow.m_Sylaby.size(); s++)
	{
		for (int i = 0; i < (int)slow.m_Sylaby[s].m_Difony.size()-1; i++)
		{
			Difon *d1 = &slow.m_Sylaby[s].m_Difony[i];
			Difon *d2 = &slow.m_Sylaby[s].m_Difony[i+1];
			bool bWywal = 0;

			if (strcmp(d1->m_pStr, "s") == 0 && strcmp(d2->m_pStr, "i") == 0)
			{
				d1->m_pStr = "s'";
				bWywal = true;				
			}
			else if (strcmp(d1->m_pStr, "z") == 0 && strcmp(d2->m_pStr, "i") == 0)
			{
				d1->m_pStr = "z'";
				bWywal = true;				
			}
			else if (strcmp(d1->m_pStr, "n") == 0 && strcmp(d2->m_pStr, "i") == 0)
			{
				d1->m_pStr = "n'";
				bWywal = true;				
			}
			else if (strcmp(d1->m_pStr, "ts") == 0 && strcmp(d2->m_pStr, "i") == 0)
			{
				d1->m_pStr = "ts'";
				bWywal = true;				
			}
			else if (strcmp(d1->m_pStr, "dz") == 0 && strcmp(d2->m_pStr, "i") == 0)
			{
				d1->m_pStr = "dz'";
				bWywal = true;				
			}

			if (bWywal)
			{
				int poz = i+1;
				while (poz < (int)slow.m_Sylaby[s].m_Difony.size()-1)
				{
					slow.m_Sylaby[s].m_Difony[poz] = slow.m_Sylaby[s].m_Difony[poz+1];
					poz++;
				}
				slow.m_Sylaby[s].m_Difony.pop_back();
				
			}
		}
	}

	// handlowanie e~ i o~
	for (int s = 0; s < slow.m_Sylaby.size(); s++)
	{
		for (int i = 0; i < slow.m_Sylaby[s].m_Difony.size(); i++)
		{
			if (strcmp(slow.m_Sylaby[s].m_Difony[i].m_pStr, "e~") == 0 || strcmp(slow.m_Sylaby[s].m_Difony[i].m_pStr, "o~") == 0)
			{
				Difon *d2 = NULL;

				if (i < slow.m_Sylaby[s].m_Difony.size()-1) d2 = &slow.m_Sylaby[s].m_Difony[i+1];
				else if (s < slow.m_Sylaby.size()-1) d2 = &slow.m_Sylaby[s+1].m_Difony[0];
				if (!d2) continue;

				if (d2->m_pStr[0] == 'p' || d2->m_pStr[0] == 'b')
				{
					if (strcmp(slow.m_Sylaby[s].m_Difony[i].m_pStr, "e~") == 0) slow.m_Sylaby[s].m_Difony[i].m_pStr = "e";
					else slow.m_Sylaby[s].m_Difony[i].m_pStr = "o";
					Difon d;
					d.m_pStr = "m";
					d.m_Param[0] = DEF_DIF_LEN_SPOL;
					d.m_Param[1] = 0;
					d.m_Param[2] = DEF_DIF_PITCH;
					d.m_bSam = false;
					slow.m_Sylaby[s].m_Difony.push_back(d);
					int poz = slow.m_Sylaby[s].m_Difony.size()-1;
					while(poz > i+1)
					{
						Difon tmp = slow.m_Sylaby[s].m_Difony[poz];
						slow.m_Sylaby[s].m_Difony[poz] = slow.m_Sylaby[s].m_Difony[poz-1];
						slow.m_Sylaby[s].m_Difony[poz-1] = tmp;
						poz--;
					}
				}
				else if (strcmp(d2->m_pStr, "t") == 0 || strcmp(d2->m_pStr, "d") == 0 || strcmp(d2->m_pStr, "ts") == 0 ||
					strcmp(d2->m_pStr, "tS") == 0 || strcmp(d2->m_pStr, "dz") == 0 || strcmp(d2->m_pStr, "dZ") == 0)
				{
					if (strcmp(slow.m_Sylaby[s].m_Difony[i].m_pStr, "e~") == 0) slow.m_Sylaby[s].m_Difony[i].m_pStr = "e";
					else slow.m_Sylaby[s].m_Difony[i].m_pStr = "o";
					Difon d;
					d.m_pStr = "n";
					d.m_Param[0] = DEF_DIF_LEN_SPOL;
					d.m_Param[1] = 0;
					d.m_Param[2] = DEF_DIF_PITCH;
					d.m_bSam = false;
					slow.m_Sylaby[s].m_Difony.push_back(d);
					int poz = slow.m_Sylaby[s].m_Difony.size()-1;
					while(poz > i+1)
					{
						Difon tmp = slow.m_Sylaby[s].m_Difony[poz];
						slow.m_Sylaby[s].m_Difony[poz] = slow.m_Sylaby[s].m_Difony[poz-1];
						slow.m_Sylaby[s].m_Difony[poz-1] = tmp;
						poz--;
					}
				}
				else if (strcmp(d2->m_pStr, "ts'") == 0 || strcmp(d2->m_pStr, "dz'") == 0)
				{
					if (strcmp(slow.m_Sylaby[s].m_Difony[i].m_pStr, "e~") == 0) slow.m_Sylaby[s].m_Difony[i].m_pStr = "e";
					else slow.m_Sylaby[s].m_Difony[i].m_pStr = "o";
					Difon d;
					d.m_pStr = "n'";
					d.m_Param[0] = DEF_DIF_LEN_SPOL;
					d.m_Param[1] = 0;
					d.m_Param[2] = DEF_DIF_PITCH;
					d.m_bSam = false;
					slow.m_Sylaby[s].m_Difony.push_back(d);
					int poz = slow.m_Sylaby[s].m_Difony.size()-1;
					while(poz > i+1)
					{
						Difon tmp = slow.m_Sylaby[s].m_Difony[poz];
						slow.m_Sylaby[s].m_Difony[poz] = slow.m_Sylaby[s].m_Difony[poz-1];
						slow.m_Sylaby[s].m_Difony[poz-1] = tmp;
						poz--;
					}
				}
				else if (strcmp(d2->m_pStr, "k") == 0 || strcmp(d2->m_pStr, "g") == 0)
				{
					if (strcmp(slow.m_Sylaby[s].m_Difony[i].m_pStr, "e~") == 0) slow.m_Sylaby[s].m_Difony[i].m_pStr = "e";
					else slow.m_Sylaby[s].m_Difony[i].m_pStr = "o";
					Difon d;
					d.m_pStr = "N";
					d.m_Param[0] = DEF_DIF_LEN_SPOL;
					d.m_Param[1] = 0;
					d.m_Param[2] = DEF_DIF_PITCH;
					d.m_bSam = false;
					slow.m_Sylaby[s].m_Difony.push_back(d);
					int poz = slow.m_Sylaby[s].m_Difony.size()-1;
					while(poz > i+1)
					{
						Difon tmp = slow.m_Sylaby[s].m_Difony[poz];
						slow.m_Sylaby[s].m_Difony[poz] = slow.m_Sylaby[s].m_Difony[poz-1];
						slow.m_Sylaby[s].m_Difony[poz-1] = tmp;
						poz--;
					}
				}
			}
		}
	}


	if (akcent < 0)
	{
		akcent = 0;
	}

	if (slow.m_Sylaby.size() > 1)
	{
		for (int i = 0; i < slow.m_Sylaby[akcent].m_Difony.size(); i++)
		{
			if (slow.m_Sylaby[akcent].m_Difony[i].m_bSam)
			{
				slow.m_Sylaby[akcent].m_Difony[i].m_Param[0] += AKC_LEN_ADD_SAM;
				slow.m_Sylaby[akcent].m_Difony[i].m_Param[2] += AKC_PITCH_ADD_SAM;
			}
			else
			{
				slow.m_Sylaby[akcent].m_Difony[i].m_Param[0] += AKC_LEN_ADD_SPOL;
				slow.m_Sylaby[akcent].m_Difony[i].m_Param[2] += AKC_PITCH_ADD_SPOL;
			}
		}
	}

	if (!slow.m_Sylaby[slow.m_Sylaby.size()-1].m_Difony[slow.m_Sylaby[slow.m_Sylaby.size()-1].m_Difony.size()-1].m_bSam)
	{
		slow.m_Sylaby[slow.m_Sylaby.size()-1].m_Difony[slow.m_Sylaby[slow.m_Sylaby.size()-1].m_Difony.size()-1].m_Param[0]+= 30;
	}
	else
	{
		slow.m_Sylaby[slow.m_Sylaby.size()-1].m_Difony[slow.m_Sylaby[slow.m_Sylaby.size()-1].m_Difony.size()-1].m_Param[0]+= 15;
	}
	
	m_Slowa.pop_back();
	m_Slowa.push_back(slow);

	// Udzwiecznianie / ubezdzwiecznianie miedzywyrazowe

	if (m_Slowa.size() > 1)
	{
		Difon *d1 = &m_Slowa[m_Slowa.size()-2].m_Sylaby[m_Slowa[m_Slowa.size()-2].m_Sylaby.size()-1].m_Difony[m_Slowa[m_Slowa.size()-2].m_Sylaby[m_Slowa[m_Slowa.size()-2].m_Sylaby.size()-1].m_Difony.size()-1];
		Difon *d2 = &m_Slowa[m_Slowa.size()-1].m_Sylaby[0].m_Difony[0];

		if (d1->IsDzwieczny() && !d2->IsDzwieczny())
		{
			d1->ChangeToBezdzwieczny();
		}
		else if (!d1->IsDzwieczny() && d2->IsDzwieczny())
		{
			d1->ChangeToDzwieczny();
		}
	}

}

void Zdanie::AddZnak(int znak)
{
	if (g_Val.str[0] == ' ')
	{
		if (m_Slowa.size() > 0 && m_Slowa[m_Slowa.size()-1].m_Sylaby.size() > 0)
		{
			CloseSlowo();
			m_Slowa.push_back(Slowo());
		}
	}
	else if (g_Val.str[0] == ',')
	{
		if (m_Slowa.size() > 0 && m_Slowa[m_Slowa.size()-1].m_Sylaby.size() > 0)
		{
			CloseSlowo();
			m_Slowa[m_Slowa.size()-1].m_bPrzecinek = true;
			m_Slowa.push_back(Slowo());
		}
	}
	else
	{
		if (m_Slowa.size() == 0) m_Slowa.push_back(Slowo());
		m_Slowa[m_Slowa.size()-1].AddZnak(znak);
	}
}

void Zdanie::Output()
{
	printf(" Zdanie ma %d sw:\n", m_Slowa.size());
	for (int i = 0; i < m_Slowa.size(); i++)
	{
		m_Slowa[i].Output();
	}
	fprintf(g_Out, "_ %d\n", ZDANIE_ODSTEP_LEN);
}

Slowo::Slowo()
{
	m_bPrzecinek = false;
}

void Slowo::AddZnak(int znak)
{
	m_Sylaby.push_back(Sylaba(g_Val.str));
}

void Slowo::Offset(int off, int len)
{
	for (int i = 0; i < m_Sylaby.size(); i++)
	{
		for (int d = 0; d < m_Sylaby[i].m_Difony.size(); d++)
		{
			m_Sylaby[i].m_Difony[d].m_Param[2] += off;
			m_Sylaby[i].m_Difony[d].m_Param[0] += len;
		}
	}
}

void Slowo::Output()
{
	printf("  Sowo ma %d sylab:\n", m_Sylaby.size());
	for (int i = 0; i < m_Sylaby.size(); i++)
	{
		m_Sylaby[i].Output();
	}
	if(m_bPrzecinek) fprintf(g_Out, "_ %d\n", PRZECINEK_LEN);
	//else fprintf(g_Out, "_ %d\n", SLOWO_ODSTEP_LEN);
	fprintf(g_Out, "\n");
}

 Sylaba::Sylaba(char *str)
 {
	m_Difony.push_back(Difon());
	m_Difony[0].m_pStr = str;
	m_Difony[0].m_Param[0] = g_bSam ? DEF_DIF_LEN_SAM : DEF_DIF_LEN_SPOL;
	m_Difony[0].m_Param[1] = 0;
	m_Difony[0].m_Param[2] = DEF_DIF_PITCH;
	m_Difony[0].m_bSam = g_bSam;
 }

 void Sylaba::Output()
 {
	 printf("   Sylaba ma %d difonow:\n", m_Difony.size());
	 for (int i = 0; i < m_Difony.size(); i++)
	 {
		 fprintf(g_Out, "%s %d %d %d\n", m_Difony[i].m_pStr, m_Difony[i].m_Param[0]+DIFON_RAND_LEN_OFF, m_Difony[i].m_Param[1], m_Difony[i].m_Param[2]+rand()%DIFON_RAND_OFF); 
		 printf("    Difon %d: %s\n", i+1, m_Difony[i].m_pStr);
	 }
 }

 Slowo Slowo::ProcessSyladebilus()
 {
	Slowo ns;

	ns.m_Sylaby.push_back(Sylaba());
	ns.m_Sylaby[0].m_Difony.push_back(m_Sylaby[m_Sylaby.size()-1].m_Difony[0]);
	m_Sylaby.pop_back();

	while (m_Sylaby.size() > 0)
	{
		if (m_Sylaby[m_Sylaby.size()-1].m_Difony[0].m_bSam)
		{
			ns.m_Sylaby[0].m_Difony.insert(ns.m_Sylaby[0].m_Difony.begin(), m_Sylaby[m_Sylaby.size()-1].m_Difony[0]);
			m_Sylaby.pop_back();

			if (m_Sylaby.size() == 1 && m_Sylaby[m_Sylaby.size()-1].m_Difony[0].m_bSam)
			{
				ns.m_Sylaby.insert(ns.m_Sylaby.begin(), Sylaba());
			}
		}
		else
		{
			ns.m_Sylaby[0].m_Difony.insert(ns.m_Sylaby[0].m_Difony.begin(), m_Sylaby[m_Sylaby.size()-1].m_Difony[0]);
			m_Sylaby.pop_back();
			
			if (m_Sylaby.size() > 0)
			{
				if (m_Sylaby.size() != 1 || m_Sylaby[m_Sylaby.size()-1].m_Difony[0].m_bSam)
					ns.m_Sylaby.insert(ns.m_Sylaby.begin(), Sylaba());
			}

			if (m_Sylaby.size() > 0 && !m_Sylaby[m_Sylaby.size()-1].m_Difony[0].m_bSam)
			{
				ns.m_Sylaby[0].m_Difony.insert(ns.m_Sylaby[0].m_Difony.begin(), m_Sylaby[m_Sylaby.size()-1].m_Difony[0]);
				m_Sylaby.pop_back();
			}
		}
	}

	return ns;	
 }

 bool Difon::IsDzwieczny()
 {
	if (m_pStr[0] == 'p') return false;
	if (m_pStr[0] == 't') return false;
	if (m_pStr[0] == 'k') return false;
	if (m_pStr[0] == 's') return false;
	if (m_pStr[0] == 'S') return false;
	if (m_pStr[0] == 'f') return false;
	if (m_pStr[0] == 'x') return false;
	return true;
 }

 void Difon::ChangeToBezdzwieczny()
 {
	if (strcmp(m_pStr, "b") == 0) 
	{
		m_pStr = "p";
		return;
	}
	if (strcmp(m_pStr, "d") == 0) 
	{
		m_pStr = "t";
		return;
	}
	if (strcmp(m_pStr, "g") == 0) 
	{
		m_pStr = "k";
		return;
	}
	if (strcmp(m_pStr, "dz") == 0) 
	{
		m_pStr = "ts";
		return;
	}
	if (strcmp(m_pStr, "dz'") == 0) 
	{
		m_pStr = "ts'";
		return;
	}
	if (strcmp(m_pStr, "dZ") == 0) 
	{
		m_pStr = "tS";
		return;
	}
	if (strcmp(m_pStr, "v") == 0) 
	{
		m_pStr = "f";
		return;
	}
	if (strcmp(m_pStr, "z") == 0) 
	{
		m_pStr = "s";
		return;
	}
	if (strcmp(m_pStr, "z'") == 0) 
	{
		m_pStr = "s'";
		return;
	}
	if (strcmp(m_pStr, "Z") == 0) 
	{
		m_pStr = "S";
		return;
	}
 }

 void Difon::ChangeToDzwieczny()
 {
	 if (strcmp(m_pStr, "p") == 0) 
	 {
		 m_pStr = "b";
		 return;
	 }
	 if (strcmp(m_pStr, "t") == 0) 
	 {
		 m_pStr = "d";
		 return;
	 }
	 if (strcmp(m_pStr, "k") == 0) 
	 {
		 m_pStr = "g";
		 return;
	 }
	 if (strcmp(m_pStr, "ts") == 0) 
	 {
		 m_pStr = "dz";
		 return;
	 }
	 if (strcmp(m_pStr, "ts'") == 0) 
	 {
		 m_pStr = "dz'";
		 return;
	 }
	 if (strcmp(m_pStr, "tS") == 0) 
	 {
		 m_pStr = "dZ";
		 return;
	 }
	 if (strcmp(m_pStr, "f") == 0) 
	 {
		 m_pStr = "v";
		 return;
	 }
	 if (strcmp(m_pStr, "s") == 0) 
	 {
		 m_pStr = "z";
		 return;
	 }
	 if (strcmp(m_pStr, "s'") == 0) 
	 {
		 m_pStr = "z'";
		 return;
	 }
	 if (strcmp(m_pStr, "S") == 0) 
	 {
		 m_pStr = "Z";
		 return;
	 }
 }


